# Build configuration

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 0
%endif

%bcond_without examples

# Versioning

%define qtmajor 6
%define qtminor 7
%define qtsubminor 2
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 1

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qtwayland-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqtwaylandclient      	    %mklibname qt%{qtmajor}waylandclient %{qtmajor}
%define libqtwaylandcompositor  	    %mklibname qt%{qtmajor}waylandcompositor %{qtmajor}
%define libqtwlshellintegration 	    %mklibname qt%{qtmajor}wlshellintegration %{qtmajor}
%define libqtwaylandeglclienthwintegration  %mklibname qt%{qtmajor}waylandeglclienthwintegration %{qtmajor}
%define libqtlandeglcompositorhwintegration %mklibname qt%{qtmajor}waylandeglcompositorhwintegration %{qtmajor}

%define libqtwayland_d          	    %mklibname qt%{qtmajor}waylandclient -d

Name:           qtwayland6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} Wayland platform support and QtCompositor module
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
## Upstream patches

## Branch Patchs

## Trunk Patchs

## Patch from Mageia

BuildRequires:  cmake
BuildRequires:  ninja
BuildRequires:  qtbase6-qtpaths
BuildRequires:  qtbase6-devel >= %{version}

BuildRequires:  cmake(Qt6Core) >= %{version}
BuildRequires:  cmake(Qt6DBus) >= %{version}
BuildRequires:  cmake(Qt6OpenGL) >= %{version}
BuildRequires:  cmake(Qt6Quick) >= %{version}
BuildRequires:  cmake(Qt6Widgets) >= %{version}

BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(wayland-scanner)
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(wayland-client)
BuildRequires:  pkgconfig(wayland-cursor)
BuildRequires:  pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(xcomposite)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(fontconfig)

BuildRequires:  re2c >= 0.11.3

BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(libpci)
BuildRequires:  pkgconfig(nss)

Provides:       qt%{qtmajor}-qtwayland = %{version}-%{release}

%description
Qt%{qtmajor} Wayland platform support and QtCompositor module.

%files
%{_qt6_libexecdir}/qtwaylandscanner
%{_qt6_plugindir}/platforms/*.so
%{_qt6_plugindir}/wayland-decoration-client/
%{_qt6_plugindir}/wayland-graphics-integration-client/
%{_qt6_plugindir}/wayland-graphics-integration-server/
%{_qt6_plugindir}/wayland-shell-integration/
%{_qt6_qmldir}/QtWayland/Client/TextureSharing/
%{_qt6_qmldir}/QtWayland/Compositor/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtWayland%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools6-assistant
Recommends:     qttools6-assistant

%description doc
Documentation for APIs and tools in QtWayland%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt6_docdir}/qtwayland*.qch
%{_qt6_docdir}/qtwayland*/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandclient}
Summary:        Qt%{qtmajor} Wayland Client Library
Group:          System/Libraries

%description -n %{libqtwaylandclient}
Qt%{qtmajor} Wayland Client Component Library.

%files -n %{libqtwaylandclient}
%{_qt6_libdir}/libQt6WaylandClient.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandcompositor}
Summary:        Qt%{qtmajor} Wayland Compositor Library
Group:          System/Libraries

%description -n %{libqtwaylandcompositor}
Qt%{qtmajor} Wayland Compositor Component Library.

%files -n %{libqtwaylandcompositor}
%{_qt6_libdir}/libQt6WaylandCompositor.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwlshellintegration}
Summary:        Qt%{qtmajor} Wayland Shell Integration Library
Group:          System/Libraries

%description -n %{libqtwlshellintegration}
Qt%{qtmajor} Wayland Shell Integration Component Library.

%files -n %{libqtwlshellintegration}
%{_qt6_libdir}/libQt6WlShellIntegration.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandeglclienthwintegration}
Summary:        Qt%{qtmajor} Wayland Egl Client Hw Integration Library
Group:          System/Libraries

%description -n %{libqtwaylandeglclienthwintegration}
Qt%{qtmajor} Wayland Egl Client Hw Integration Component Library.

%files -n %{libqtwaylandeglclienthwintegration}
%{_qt6_libdir}/libQt6WaylandEglClientHwIntegration.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtlandeglcompositorhwintegration}
Summary:        Qt%{qtmajor} Wayland Egl Compositor Hw Integration Library
Group:          System/Libraries

%description -n %{libqtlandeglcompositorhwintegration}
Qt%{qtmajor} Wayland Egl Compositor Hw Integration Component Library.

%files -n %{libqtlandeglcompositorhwintegration}
%{_qt6_libdir}/libQt6WaylandEglCompositorHwIntegration.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwayland_d}
Summary:        Devel files needed to build apps based on QtWayland
Group:          Development/KDE and Qt
Requires:       %{name} = %{version}
Requires:       %{libqtwaylandclient} = %{version}
Requires:       %{libqtwaylandcompositor} = %{version}
Requires:       %{libqtwlshellintegration} = %{version}
Requires:       %{libqtwaylandeglclienthwintegration} = %{version}
Requires:       %{libqtlandeglcompositorhwintegration} = %{version}

Provides:       libqtwayland6-devel = %{version}
Provides:       libqt6wayland-devel = %{version}
Provides:       qtwayland6-devel = %{version}
Provides:       qt6wayland-devel = %{version}
Provides:       qt%{qtmajor}-qtwayland-devel = %{version}-%{release}

Provides:       libqt6wayland-private-devel = %{version}
Provides:       libqtwayland6-private-devel = %{version}
Provides:       qtwayland6-private-devel = %{version}
Provides:       qt6wayland-private-devel = %{version}

%description -n %{libqtwayland_d}
Devel files needed to build apps based on Qt Wayland.

%files -n %{libqtwayland_d}
%{_qt6_includedir}/QtWaylandClient/
%{_qt6_libdir}/libQt6WaylandClient.so
%{_qt6_libdir}/cmake/Qt6WaylandClient/
%{_qt6_libdir}/pkgconfig/Qt6WaylandClient.pc
%{_qt6_libdir}/libQt6WaylandClient.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_waylandclient.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_waylandclient_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6waylandclient_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/WaylandClient.json
#
%{_qt6_includedir}/QtWaylandCompositor/
%{_qt6_libdir}/libQt6WaylandCompositor.so
%{_qt6_libdir}/cmake/Qt6WaylandCompositor/
%{_qt6_libdir}/pkgconfig/Qt6WaylandCompositor.pc
%{_qt6_libdir}/libQt6WaylandCompositor.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6waylandcompositor_*_metatypes.json
%{_qt6_libdir}/qt6/modules/WaylandCompositor.json
#
%{_qt6_includedir}/QtWaylandEglCompositorHwIntegration/
%{_qt6_libdir}/libQt6WaylandEglCompositorHwIntegration.so
%{_qt6_libdir}/cmake/Qt6WaylandEglCompositorHwIntegrationPrivate/
%{_qt6_libdir}/libQt6WaylandEglCompositorHwIntegration.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_wayland_egl_compositor_hw_integration_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6waylandeglcompositorhwintegrationprivate_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/WaylandEglCompositorHwIntegrationPrivate.json
#
%{_qt6_includedir}/QtWaylandEglClientHwIntegration/
%{_qt6_libdir}/libQt6WaylandEglClientHwIntegration.so
%{_qt6_libdir}/cmake/Qt6WaylandEglClientHwIntegrationPrivate/
%{_qt6_libdir}/libQt6WaylandEglClientHwIntegration.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_wayland_egl_client_hw_integration_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6waylandeglclienthwintegrationprivate_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/WaylandEglClientHwIntegrationPrivate.json
#
%{_qt6_includedir}/QtWlShellIntegration/
%{_qt6_libdir}/libQt6WlShellIntegration.so
%{_qt6_libdir}/cmake/Qt6WlShellIntegrationPrivate/
%{_qt6_libdir}/libQt6WlShellIntegration.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_wl_shell_integration_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6wlshellintegrationprivate_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/WlShellIntegrationPrivate.json
#
%{_qt6_includedir}/QtWaylandGlobal/
%{_qt6_libdir}/cmake/Qt6WaylandGlobalPrivate/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_waylandglobal_private.pri
%{_qt6_libdir}/qt6/modules/WaylandGlobalPrivate.json
#
%if %{with examples}
%{_qt6_examplesdir}/wayland/
%endif
#
%{_qt6_libdir}/cmake/Qt6Gui/*.cmake
%{_qt6_libdir}/cmake/Qt6Qml/QmlPlugins/Qt6Wayland*
%{_qt6_libdir}/cmake/Qt6Qml/QmlPlugins/Qt6qwaylandcompositorplugin*
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtWaylandTestsConfig.cmake
%{_qt6_libdir}/cmake/Qt6WaylandScannerTools/
%{_qt6_libdir}/cmake/Qt6/FindWaylandkms.cmake

#------------------------------------------------------------------------------

%prep
%setup -q -n qtwayland-everywhere-src-%{qtversion}
%autopatch -p1

%build
%cmake_qt6 %{!?with_examples:-DQT_BUILD_EXAMPLES:BOOL=OFF}

%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete


%changelog
* Wed Jul 31 2024 daviddavid <daviddavid> 6.7.2-1.mga10
+ Revision: 2083124
- New version 6.7.2

* Tue Jun 11 2024 daviddavid <daviddavid> 6.7.1-2.mga10
+ Revision: 2072564
- rebuild for 'Qt_$MAJOR_PRIVATE_API' settings

* Thu May 23 2024 daviddavid <daviddavid> 6.7.1-1.mga10
+ Revision: 2066233
- New version 6.7.1

* Thu Feb 15 2024 daviddavid <daviddavid> 6.6.2-1.mga10
+ Revision: 2041672
- New version 6.6.2

* Thu Oct 19 2023 daviddavid <daviddavid> 6.6.0-1.mga10
+ Revision: 1999064
- New version 6.6.0

* Mon Sep 11 2023 neoclust <neoclust> 6.5.2-1.mga10
+ Revision: 1986122
- New version 6.5.2

* Wed Jan 04 2023 daviddavid <daviddavid> 6.4.1-3.mga9
+ Revision: 1929858
- the devel sub-pkg should require the main one

* Tue Dec 27 2022 daviddavid <daviddavid> 6.4.1-2.mga9
+ Revision: 1927073
- build examples

* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923064
- New version 6.4.1

* Tue Oct 04 2022 neoclust <neoclust> 6.4.0-1.mga9
+ Revision: 1894742
- New version 6.4.0

* Mon Aug 29 2022 neoclust <neoclust> 6.3.1-1.mga9
+ Revision: 1881655
- New version 6.3.1

* Sun Jul 31 2022 wally <wally> 6.3.0-1.mga9
+ Revision: 1874040
- disable examples as they needs pkg itself to build
+ neoclust <neoclust>
- New version 6.3.0

* Sun Apr 10 2022 tmb <tmb> 6.2.3-2.mga9
+ Revision: 1848546
- Mageia 9 Mass Rebuild

* Sun Feb 20 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1781928
- New version 6.2.3
- New version 6.2.1

* Sat Nov 13 2021 neoclust <neoclust> 6.2.0-1.mga9
+ Revision: 1756131
- New version 6.2.0

* Fri May 14 2021 daviddavid <daviddavid> 6.1.0-1.mga9
+ Revision: 1722814
- initial package qtwayland6

